#include <cstdio>
#include <cstring>
#include <algorithm>

int N;

char notPrime[1000*1000+1];
int primes[100000]={1},pcnt=1;

void GeneratePrimes()
{
    memset(notPrime,0,N*N*sizeof(char)+1);
    notPrime[0]=notPrime[1];
    int i=2;
    while(i<=N*N)
    {
        if(!notPrime[i])
        {
            //printf("%d ",i);
            int j=i*2;
            primes[pcnt++]=i;
            /*if(i<=N)
            {
                int p=i*i;
                while(p<N*N)primes[pcnt++]=p,p*=i;
            }*/
            while(j<N*N)
            {
                notPrime[j]=1;
                j+=i;
            }
        }
        i++;
    }
}

class Can
{
    int n;
    char cnt;

    public:

    Can(int num=0)
    {
        cnt=0;
        n=num;
        int it=1;
        if(notPrime[num])while(num>1)
        {
            if(!(num%primes[it]))cnt++;
            while(!(num%primes[it]))num/=primes[it];
            it++;
        }
        else cnt=1;
    }

    Can(const Can& c)
    {
        n=c.n;
        cnt=c.cnt;
    }

    int getN()const{return n;}
    char getCnt()const{return cnt;}

    bool operator<(const Can& c)const
    {
        return cnt<c.cnt||(cnt==c.cnt&&n<c.n);
    }
};

Can tab[1000*1000];

int main()
{
  int r=5,c=5;
  N=585;
  //scanf("%d %d %d",&N,&r,&c);
  GeneratePrimes();
  for(int i=0;i<N*N;i++)tab[i]=Can(i+1);
  std::sort(tab,tab+N*N);
  printf("%d",tab[N*(r-1)+c-1].getN());
}
