#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

int main()
{
    int n, r, c;
    cin >> n >> r >> c;

    int numberToSeek = (r - 1) * n + c;

    // Erathostenes' sieve to count the different prime divisors
    short divCount[n*n];
    for (int i = 0; i < n*n; i++)
    {
        divCount[i] = 0;
    }
    int cDivisor = 2, cNumber;
    while (cDivisor <= n*n)
    {
        if (divCount[cDivisor-1] == 0)
        {
            cNumber = cDivisor;
            while(cNumber <= n*n)
            {
                divCount[cNumber-1]++;
                cNumber += cDivisor;
            }
        }
        cDivisor++;
    }

    // calculate div groups' sizes
    int divGroupSize[40];
    for (int i = 0; i < 40; i++)
    {
        divGroupSize[i] = 0;
    }
    for (int i = 0; i < n*n; i++)
    {
        divGroupSize[divCount[i]]++;
    }

    // calculate the number's position
    int divGroup = 0, pos;
    while (numberToSeek > 0)
    {
//        cout << numberToSeek << " " << divGroupSize[divGroup] << endl;
//        system("pause");
        if (numberToSeek > divGroupSize[divGroup])
        {
            numberToSeek -= divGroupSize[divGroup];
        }
        else
        {
            pos = numberToSeek;
            break;
        }

        divGroup++;
    }

//    // print
//    for (int i = 0; i < 40; i++)
//    {
//        if (divGroupSize[i] == 0) break;
//        cout << i << " " << divGroupSize[i] << endl;
//    }

//    // print
//    for (int i = 0; i < n*n; i++)
//    {
//        cout << i+1 << " " << divCount[i] << endl;
//    }

    // print final result
    int count = 0;
//    cout << divGroup << " " << pos << endl;
    for (int i = 0; i < n*n; i++)
    {
        if (divCount[i] == divGroup)
        {
//            cout << "counting " << i << endl;
            count++;
        }
        if (count == pos)
        {
            cout << i+1 << endl;
            break;
        }
    }

    return 0;
}
