#include <cstdio>
#include <cstring>
char A[128][128];
int n, m;


void dfs ( int i, int j ) {
    if ( A[i][j] )
        return;
    A[i][j] = 1;
    dfs ( i + 1, j );
    dfs ( i - 1, j );
    dfs ( i, j + 1 );
    dfs ( i, j - 1 );
}

void print () {
    for ( int i = 0; i <= n + 1; i++ ) {
        for ( int j = 0; j <= m + 1; j++ ) {
            std::printf ( "%d ", A[i][j] );
        }
        std::printf  ( "\n" );
    }
}
int main () {
    int k;
    std::memset ( A, 0, sizeof ( A ) );
    std::scanf ( "%d %d %d", &n, &m, &k );
    for ( int i = 0; i <= m + 1; i++ ) {
        A[0][i] = A[n + 1][i] = 2;
    }
    for ( int i = 0; i <= n + 1; i++ ) {
        A[i][0] = A[i][m + 1] = 2;
    }
    int x, y;
    for ( int i = 0; i < k; i++ ) {
        std::scanf ( "%d %d", &x, &y );
        A[x][y] = 1;
    }
    int times = 0;
    for ( int i = 1; i <= n; i++ ) {
        for ( int j = 1; j <= m; j++ ) {

            if ( !A[i][j] ) {
                times++;
                dfs ( i, j );
            }

        }
    }
    std::printf ( "%d\n", times );
    return 0;
}
/*
6 10
21 1 4 1 10 2 5 2 9 3 1 3 2 3 3 3 4 3 5 3 6 3 7 3 8 3 9 3 10 4 6 5 3 5 2 5 6 5 9
6 6 6 8
*/
