/*
    Notes:
    I was trying an algorithm involving tree like structures and other stuff,
    but as my time was running out I noticed a pattern in some of the solutions
    that I had worked out. It was that in every odd line there was a 1 ( one )
    wiht alternating signs. Folloling patterns and logic I made a very slow
    algorithm that seems to work for all input values up to 5 ( I only tested
    that many ). I didn't have time to clean up all of the code but I cleaned
    most of it. There more than likely is some unused code.
    BTW this is probably way too slow to pass the time test of 0,4 seconds.
*/



#include <iostream>
#include <stdio.h>
#include <algorithm>        // <<- I would use these a lot more if had some doccumentation or at least working intelisence.
#include <assert.h>

using namespace std;

unsigned int N;

static const bool On = true;
static const bool Off = false;

class LampStates
{
public:
    LampStates()
    :   States( new bool[ N ] )     // Very inefficient but good enough for the time given
    {
        std::fill( States, States + N, Off );
    }
    LampStates( const LampStates &Source )
    :   States( new bool[ N ] )
    {
        for( unsigned int I = 0; I < N; ++I )
        {
            States[ I ] = Source.States[ I ];
        }
    }
    LampStates &operator=( const LampStates &Source )
    {
        // No need to check for self assignment
        for( unsigned int I = 0; I < N; ++I )
        {
            States[ I ] = Source.States[ I ];
        }
    }
    ~LampStates()
    {
        delete[] States;
    }

private:
    bool * const States;

public:
    bool AllLampsAreOn() const
    {
        for( unsigned int I = 0; I < N; ++I )
        {
            if( States[ I ] == Off )
            {
                return false;
            }
        }

        return true;
    }

    bool IsChangeState0Valid() const
    {
        for( unsigned int I = 0; I < ( N - 1 ); ++I )
        {
            if( States[ I ] == On )
            {
                return true;
            }
        }
        return false;
    }
    void ChangeState1()     // Changes the state of the first lamp
    {
        (*States) = !(*States);
    }
    void ChangeState0()     // Chnages the state of the lamp that is after the first one that is ligth.
    {
        assert( IsChangeState0Valid() );

        bool *FirstLampOn = States;
        while( (*FirstLampOn) != On )   // We're assuming that calling this is valid
        {
            ++FirstLampOn;
        }

        ++FirstLampOn;
        *FirstLampOn = !(*FirstLampOn);
    }
    int ChangeState0GetChangeInfo()    // Same as above but returns the number to print
    {
        assert( IsChangeState0Valid() );

        bool *FirstLampOn = States;
        while( (*FirstLampOn) != On )   // We're assuming that calling this is valid
        {
            ++FirstLampOn;
        }

        int Index = FirstLampOn - States;

        ++FirstLampOn;
        *FirstLampOn = !(*FirstLampOn);

        if( *FirstLampOn == On )
        {
            return Index + 2;   // Indecies start from 0 ( Lmp numbers don't )
        }
        else
        {
            return -( Index + 2 );
        }
    }
    void ChangeState( bool State )
    {
        if( State )
        {
            ChangeState1();
        }
        else
        {
            ChangeState0();
        }
    }

    // Debugging functions ( you can delete them now if you want )
    void DebugPrint() const
    {

        for( unsigned int I = 0; I < N; ++I )
        {
            if( States[ I ] == On )
            {
                cout << '+';
            }
            else
            {
                cout << '-';
            }
        }
        cout << endl;
    }
    bool *DebugPointerAccess() const
    {
        return States;
    }
};


int main()
{
    cin >> N;

    LampStates L;   // Couldn't think of a better name

    int MagicPattern = 1;

    while( !L.AllLampsAreOn() )
    {
        if( MagicPattern == 1 )
        {
            puts( "+1" );
            MagicPattern = -1;
        }
        else
        {
            puts( "-1" );
            MagicPattern = 1;
        }

        L.ChangeState1();

        if( L.AllLampsAreOn() )
        {
            break;
        }

        if( L.IsChangeState0Valid() )
        {
            const int LampNumber = L.ChangeState0GetChangeInfo();
            if( LampNumber > 0 )
            {
                cout << '+';
            }
            cout << LampNumber << endl;
        }
    }

}
