#include<iostream>
#include<cstdio>
#include<queue>
using namespace std;
int n,m,k,used[105][105],br;
void bfs(int x, int y)
{
    queue<int> q;
    q.push(x);
    q.push(y);
    while (!q.empty())
    {
        int x=q.front(),y;
        q.pop();
        y=q.front();
        q.pop();
        if (x>0 && used[x-1][y]==0)
        {
            used[x-1][y]=br;
            q.push(x-1);
            q.push(y);
        }
        if (x<n-1 && used[x+1][y]==0)
        {
            used[x+1][y]=br;
            q.push(x+1);
            q.push(y);
        }
        if (y>0 && used[x][y-1]==0)
        {
            used[x][y-1]=br;
            q.push(x);
            q.push(y-1);
        }
        if (y<m-1 && used[x][y+1]==0)
        {
            used[x][y+1]=br;
            q.push(x);
            q.push(y+1);
        }
    }
}
int main()
{
    scanf("%d%d%d",&n,&m,&k);
    for (int i=0; i<k; i++)
    {
        int x,y;
        scanf("%d%d",&x,&y);
        used[x-1][y-1]=-1;
    }
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
            if (used[i][j]==0)
            {
                br++;
                used[i][j]=br;
                bfs(i,j);
            }
    }
    printf("%d\n",br);
    return 0;
}