#include <iostream>
#include <queue>
#include <algorithm>
using namespace std;
int N, R, C;
struct number
{
    int whichNumber;
    int kolkoDeliteli;
};
typedef struct number Number;
int table[1001][1001] = {};
int sieve[1000001] = {};
int deliteli[1000001] = {};
vector<int> primes;
queue<int> numbers;
vector<Number> nnn;
bool cmp(Number a, Number b)
{
    if(a.kolkoDeliteli == b.kolkoDeliteli) return a.whichNumber < b.whichNumber;
    else return a.kolkoDeliteli < b.kolkoDeliteli;
}
void calc_sieve()
{
    for(int i = 2; i <= N; ++i)
    {
        if(sieve[i] == 0)
        {
            for(int j = 2*i; j <= N*N; j+= i)
            {
                sieve[j] = 1;
            }
        }
    }
    for(int i = 2; i <= N*N; ++i)
    {
        if(sieve[i] == 0)
        {
            primes.push_back(i);
            //cout<<"primes is: "<<i<<endl;
        }
    }
}
void solve()
{
   //cout<<"Complexity: "<<N*N*primes.size()<<endl;
   //cout<<"NUmber of primes: "<<primes.size()<<endl;
   //int calcs = 0;
    for(int i = 2; i <= N*N; ++i)
    {
        //if(sieve[i] == 0) {++deliteli[i];
        //continue;
        //}
        int toCheck = i;
        int j = 0;
        while(j < primes.size() && toCheck >= primes[j])
        {
            if(toCheck % primes[j] == 0)
            {
                toCheck /= primes[j];
                ++deliteli[i];
            }
            ++j;
        }
        
        Number a;
        a.whichNumber = i;
        a.kolkoDeliteli = deliteli[i];
        nnn.push_back(a);
    }
    //cout<<"Real complexity"<<calcs<<endl;return;
    sort(nnn.begin(), nnn.end(), cmp);
    int c = 0;
    for(int i = 1; i <= N; ++i)
    {
        for(int j = 1; j <= N; ++j)
        {
            if(i == 1 && j == 1) continue;
            table[i][j] = nnn[c].whichNumber;
            ++c;
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin >> N >> R >> C;
    calc_sieve();
    solve();
    table[1][1] = 1;
    cout<<table[R][C]<<endl;
    /*
    for(int i = 0; i < primes.size(); ++i)
    {
        cout<<"primse is: "<<primes[i]<<endl;
    }
    */
    /*
    cout<<"table:\n";
    
    for(int i = 1; i <= N; ++i)
    {
        for(int j = 1; j <= N; ++j)
        {
            cout<<table[i][j]<<" ";
        }
        cout<<endl;
    }
    */
    return 0;
}
