#include<iostream>
using namespace std;

bool CheckPrime(long a)
{
	long double a1 = a;
	for(int i = 2; i <= sqrt(a1); i++)
	{
		if(a % i == 0) return false;
	}
	return true;
}

int NumberOfPrimes(long a)
{
	int number = 0;
	for(long i = 2; i <= a / 2; i++)
	{
		if(a % i == 0 && CheckPrime(i))
			number++;
	}
	if(CheckPrime(a)) number++;
	return number;
}

void main()
{
	int N, r, c, maxPrimes = 1;
	cin>>N>>r>>c;
	long tab[15][15000];
	long tabLen[15];
	tab[0][0] = 1;
	tabLen[0] = 0;
	for(int i = 2; i <= N * N; i++)
	{
		int a = NumberOfPrimes(i);
		if(tabLen[a]>=0)
			tabLen[a]++;
		else tabLen[a] = 0;
		if(a > maxPrimes)
			maxPrimes = a;
		tab[a][tabLen[a]] = i;
	}
	int red = 0, colona = 0;
	for(int i = 0; i <= maxPrimes; i++)
	{
		for(int j = 0; j <= tabLen[i]; j++)
		{
			if(red == r-1 && colona == c-1)
			{
				cout<<tab[i][j]<<endl;
				break;
			}
			colona++;
			if(colona >= N)
			{
				red++;
				colona = 0;
			}
		}
	}
}