#include <cstdio>
#define MAX_N_M 128
using namespace std;

int n, m, k;
bool infected[MAX_N_M][MAX_N_M];
int viruses=0;

void infect(int x, int y)
{
    if(x<1||y<1||x>n||y>m)return;
    if(infected[x][y])return;
    infected[x][y]=true;
    infect(x, y+1);
    infect(x, y-1);
    infect(x+1, y);
    infect(x-1, y);
}

int main()
{
    scanf("%d%d%d", &n, &m, &k);

    for(int i=0, x, y;i<k;i++)
    {
        scanf("%d%d", &x, &y);
        infected[x][y]=true;
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(!infected[i][j])
            {
                infect(i, j);
                viruses++;
            }
        }
    }

    printf("%d\n", viruses);

    return 0;
}

/*
4 5
3
1 3
2 1
2 2
*/ // - > 2

/*
100 100
8
1 2
2 1
1 4
2 4
3 4
4 1
4 2
4 3
*/ // - > 3

/*
5 6
12
1 2
1 4
2 1
2 3
2 5
3 1
3 3
3 5
3 6
4 2
4 4
5 4
*/ // - > 7
