#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <queue>
#define MAX 100001
using namespace std;

struct worker
{
    int wage;
    int pos;
    
    worker(){}
    worker(int a, int b)
    {
        wage = a;
        pos = b;
    }
    bool operator<(const worker &other)
    const {
        return wage < other.wage;
    }
}cpy[1<<17];

int b[1<<17];
int r[1<<17], nrank[1<<17];
int cp[1<<17];
int c[1<<17];
int a[1<<17];
int na[1<<17];
int n;


int it[1<<17];

void update(int pos, int val)
{
    for(int i=pos; i<=MAX; i+=(i&(-i)))
    it[i] = max(it[i],val);
}

int query(int pos)
{
    int res = 0;
    if(pos == 0) return 0;
    for(int i=pos; i>=1; i-=(i&(-i)))
    res = max(res,it[i]);
    return res;
}

int main()
{
    scanf("%d", &n);
    
    for(int i=0; i<n; i++)
    {
        scanf("%d", &a[i]);
    }
    
    //compression to see ranks;
    for(int i=0; i<n; i++) b[i] = a[i];
    for(int i=0; i<n; i++) na[i] = a[i];
    sort(b,b+n);
    
    for(int i=0; i<n; i++) r[i] = lower_bound(b,b+n,a[i]) - b;
    
    //for(int i=0; i<n; i++) cout << r[i] << ' '; cout << endl;
    int cr;
    bool ok=0;
    for(int rep = 1; rep <=12; rep++)
    {
        for(int i=0; i<n; i++) cp[i] = MAX-na[i];
        for(int i=0; i<n; i++) c[i] = na[i];
        
        for(int i=0; i<=MAX; i++) it[i] = 0;
        
        
        
        for(int i=n-1; i>=0; i--) 
        {
            update(cp[i],n-i);
            cr = query(cp[i]-1);
            //cout << i << ' ' << cp[i] << ' ' << cr << endl;
            if(cr > 0)
            {
                c[i] = (na[i]+na[n-cr])/2;
            }
        }
        
        
        for(int i=0; i<n; i++) b[i] = c[i];
        sort(b,b+n);
        for(int i=0; i<n; i++) nrank[i] = lower_bound(b,b+n,c[i]) - b;
        
        //for(int i=0; i<n; i++) {cout << c[i] << ' ';} cout << endl;
        
        ok = true;
        for(int i=0; i<n; i++) {
            if(r[i] != nrank[i]) {ok=false; break;}
        }
        if(!ok) break;
        
        ok = false;
        for(int i=0; i<n; i++) if(c[i] != na[i]) {ok=true; break;}
        
        if(ok) for(int i=0; i<n; i++) na[i] = c[i];
        else break;
        
    }
    
    for(int i=0; i<n; i++) cout << na[i] << endl;
}