#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#define MAXN 1000

using namespace std;

struct Number {
  int primes;
  int num;
};

Number nums[MAXN*MAXN];

bool cmp(const Number &a, const Number &b) {
  return a.primes==b.primes ? a.num<b.num: a.primes<b.primes;
}

int main() {
  int n, r, c;
  cin >> n >> r >> c;

  r--; c--;

  int i, j, nsq = n*n;
  for(i=0; i<nsq; i++) {
    nums[i].primes=0;
    nums[i].num=i+1;
  }

  for(i=1; i<nsq; i++) {
    if(nums[i].primes==0) {
      nums[i].primes=1;
      j=nums[i].num+nums[i].num-1;
      while(j<=nsq) {
        nums[j].primes += 1;
        j += nums[i].num;
      }
    }
  }

  sort(nums, nums + nsq, cmp);
  cout << nums[r*n+c].num << endl;

  return 0;
}
