# include <cstdio>
# include <algorithm>
# include <string>
# include <cstring>
# include <cstdlib>
# include <vector>
# include <map>
# include <queue>

using namespace std;

struct yo
{
	int a;
	int b;
};

yo a[8] = {{- 1, 0}, {0, - 1}, {1, 0}, {0, 1}};

int n, m, k;

int used [128][128];

int p, q;

int vis;

int ans;

void read ()
{
	int i;
	scanf ("%d%d%d", &n, &m, &k);
	for (i = 0; i < k; i ++)
	{
		scanf ("%d%d", &p, &q);
		used [p][q] = 1;
	}
	vis = k;
}

void dfs (int x, int y)
{
	int i;
	used [x][y] = 1;
	vis ++;
	for (i = 0; i < 4; i ++)
	{
		if (x + a[i].a < 1) continue;
		if (x + a[i].a > n) continue;
		if (y + a[i].b < 1) continue;
		if (y + a[i].b > m) continue;
		if (used [x + a[i].a][y + a[i].b] == 1) continue;
		dfs (x + a[i].a, y + a[i].b);
	}
}

void solve ()
{
	int i, j;
	for (i = 1; i <= n; i ++)
	for (j = 1; j <= m; j ++)
	{
		if (used [i][j] == 0)
		{
			dfs (i, j);
			ans ++;
			if (vis == n * m) return;
		}
	}
}

int main ()
{
	read ();
	solve ();
	printf ("%d\n", ans);
	return 0;
}

