#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct competitor
{
    int number;
    vector<int> songs;
};

struct competition
{
    int number;
    vector<competitor> competitors;
};

class competitorSort
{
public:
    bool operator()(competitor a, competitor b)
    {
        return a.number<b.number;
    }
};

int main()
{
    vector<competition> competitions;
    vector<competitor> competitors;
    int m,n;
    cin>>m>>n;
    for(int i=0; i<n; i++)
    {
        competitor temp;
        temp.number = i+1;
        competitors.push_back(temp);
    }
    for(int i=0; i<m; i++)
    {
        competition temp;
        temp.number = i;
        temp.competitors = vector<competitor>();
        int b;
        cin>>b;
        for(int j=0; j<b; j++)
        {
            competitor t;
            cin>>t.number;
            temp.competitors.push_back(t);
        }
        sort(temp.competitors.begin(),temp.competitors.end(),competitorSort());
        competitions.push_back(temp);
    }
    int br=0;
    for(int i=0; i<competitions.size(); i++)
    {
        if(competitions[i].competitors[0].number==1)
        {
            for(int j=1; j<competitions[i].competitors.size(); j++)
            {
                competitors[competitions[i].competitors[j].number-1].songs.push_back(br);
            }
            br++;
        }
        else
        {
            for(int j=0; j<competitions[i].competitors.size(); j++)
            {
                vector<int> compSongs;
                for(int k=0; k<competitors[competitions[i].competitors[j].number-1].songs.size(); k++)
                {
                    compSongs.push_back(competitors[competitions[i].competitors[j].number-1].songs[k]);
                }
                for(int k=0; k<competitions[i].competitors.size(); k++)
                {
                    for(int l=0; l<compSongs.size(); l++)
                    {
                        competitors[competitions[i].competitors[k].number-1].songs.push_back(compSongs[l]);
                    }
                }
            }
        }
    }

    vector<int> answer;

    for(int i=0; i<competitors.size(); i++)
    {
        bool fl = true;
        sort(competitors[i].songs.begin(),competitors[i].songs.end());
        for(int j=0; j<br; j++)
        {
            if(!binary_search(competitors[i].songs.begin(),competitors[i].songs.end(),j)){
                fl = false;
                break;
            }
        }
        if(fl){
            answer.push_back(i+1);
        }
    }
    cout<<answer.size();
    if(answer.size()>0){
        cout<<endl;
    }
    for(int i=0;i<answer.size();i++){
        cout<<answer[i];
        if(i!=answer.size()-1) cout<<" ";
    }
    return 0;
}
