#include <iostream>
#include <vector>

using namespace std;
class Employee{
    int salary;
    vector<Employee> sameSalarys;
    vector<Employee> smallerThanEmployees;
public:
    void setValues(int pay){
    salary = pay;
    }
    void increasePay(int otherPay){
        salary = (salary + otherPay) / 2;
    }
    int getSalary(){
        return salary;
    }
    void addSameSalarys(Employee otherEmployee){
        sameSalarys.push_back(otherEmployee);
    }
    void addSmallerThan(Employee otherEmployee){
        smallerThanEmployees.push_back(otherEmployee);
    }
    bool currentSmallerThanOthers(){
          for(int i = 0; i<smallerThanEmployees.size(); i++){
            if(salary > smallerThanEmployees[i].getSalary()){
                return true;
            }
        }
        return true;
    }
    bool checkCurrentWithOthers(){
        for(int i=0;i<sameSalarys.size();i++){
            if(salary != sameSalarys[i].getSalary())
                return false;
        }
        return true;
    }
};

int main()
{
   int n = 0;
   cin >> n;
   vector<Employee> employees;
   vector<Employee> employeesOld;
   for(int i = 0; i<n; i++){
        int pay = 0;
        cin >> pay;
        Employee employee;
        employee.setValues(pay);
        employees.push_back(employee);
   }
   for(int i=0; i <= n-1; i++){
        for(int j = i+1; j<=n-1; j++){
            if(employees[i].getSalary() == employees[j].getSalary())
                employees[i].addSameSalarys(employees[j]);
            if(employees[i].getSalary() < employees[j].getSalary())
                employees[i].addSmallerThan(employees[j]);
        }
   }
   bool exitCycles = false, exitCyclesBigger = false;
   for(int countToTwelve = 0; countToTwelve < 12; countToTwelve++){
       if(countToTwelve != 0 ){
            for(int j =0; j<= n-1; j++){
               if(!(employees[j].checkCurrentWithOthers())){
                    exitCyclesBigger = true;
                    break;
               }
               if(employees[j].currentSmallerThanOthers()){
                    exitCycles = true;
                    break;
               }
            }
       }
       if(exitCycles || exitCyclesBigger){
          break;
       }
       for(int i = 0; i<n; i++){
            employeesOld.push_back(employees[i]);
            if(i == n -1) break;
            int currentEmplSal = employees[i].getSalary();
            int nextEmplSal = employees[i+1].getSalary();
            if(currentEmplSal < nextEmplSal){
                employees[i].increasePay(nextEmplSal);
            }
       }
   }
    for(int i =0; i<n;i++){
        if(!exitCyclesBigger){
            cout << employees[i].getSalary() << endl;
        }
        else{
            cout << employeesOld[i].getSalary()<<endl;
        }
    }
    return 0;
}
