#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef multimap<int, int>::iterator mmiter;

bool check_status(vector<int>& curr, vector<int>& last){
    multimap<int, int> ind1, ind2; //but it is not balanced
    for(int i = 0; i < last.size(); ++i){
        ind1.insert(pair<int, int>(last.at(i), i));
        ind2.insert(pair<int, int>(curr.at(i), i));
    }
    mmiter it1 = ind1.begin();
    mmiter it2 = ind2.begin();
    bool good = true;
    for(; it1 != ind1.end(); ++it1, ++it2){
        if(it1->second != it2->second)good = false;
        if(!good)return false;
    }
    return true;
}

int main(){
    vector<int> salaries, prev;
    int count;
    bool flag;
    cin >> count;
    for(int i = 0; i < count; ++i){
        int amount;
        cin >> amount;
        salaries.push_back(amount);
    }
    for(int i = 0; i < 12; ++i){
        prev = salaries;
        flag = false;
        for(int a = 0; a < salaries.size(); ++a){
            for(int j = a; j < salaries.size(); ++j){
                if(salaries.at(j) > salaries.at(a)){
                        salaries.at(a) = (salaries.at(a) + salaries.at(j))/2;
                        if(salaries.at(a) != prev.at(a))flag = true;
                        break;
                }
            }
        }
        if(!check_status(prev, salaries) || !flag)break;
        cout << endl;

    }
    for(int a = 0; a < prev.size(); ++a){
        cout << prev.at(a) << endl;
    }
    return 0;
}
