#include <iostream>
#include <cstring>
#include <map>
using namespace std;

#define MAXLEN 20
char name[MAXLEN+1];
map <const char, int> numbers;
int lineOf(int a)
{
    return a>=1 && a<=9 ? 0 :
           (a>=10 && a<=18 ? 1 : 2);
}
void initNumbers()
{
    int capitolLetterSize='A'-'a';
    int inti;
    for (int i='a'; i<='z'; ++i)
    {
        inti=(i-'a')+1;
        numbers[i]=inti-(9*lineOf(inti));
        numbers[i+capitolLetterSize]=inti-(9*lineOf(inti));
    }
}
int calculateNameSum()
{
    int len=strlen(name);
    int sum=0;
    for (int i=0; i<len; ++i)
        sum+=numbers[name[i]];
    return sum;
}
int convertToSingleNumber(int number)
{
    if (number<10 || number==33) return number;
    int sum=0;
    while (number>0)
    {
        sum+=number%10;
        number/=10;
    }
    return convertToSingleNumber(sum);
}
int main()
{
    initNumbers();
    cin >> name;
    cout << convertToSingleNumber(calculateNameSum());
    cout << endl;
    return 0;
}
