#include <cstdio>

#define cmp(a,b) ((a>b)? (1) : ((a<b)? (-1) : (0)))
#define avg(a,b) ((a+b)/2)

int n;
int* a;
int* b;
int* tmp;

void input ();
void sol ();
void output ();

int main ()
{
    input ();
    sol ();
    output ();

    return 0;
}

void input ()
{
    scanf ("%d", &n);

    a = new int[n + 1];
    a[0] = 0;
    b = new int[n + 1];
    b[0] = 0;
    for (int i = 1; i < n + 1 ; i++)
        scanf ("%d", &a[i]);
}

void sol ()
{
    bool f = false;
    for (int t = 0; t < 12; t++)
    {
        for (int i = 1; i < n ; i++)
        {
            for (int j = i + 1; j < n + 1; j++)
                if (a[i] < a[j])
                {
                    b[i] = avg (a[i], a[j]);
                    f = true;
                    break;
                }

            if (!f)
                b[i] = a[i];
            f = false;
        }

        b[n] = a[n];

        for (int i = 1; i < n + 1; i++)
            for (int j = i + 1; j < n + 1; j++)
                if (cmp (a[i], a[j]) != cmp (b[i], b[j]))
                    return;

        tmp = a;
        a = b;
        b = tmp;
    }
}

void output ()
{
    for (int i = 1; i < n + 1; i ++)
        printf ("%d\n", a[i]);

}

/*
4
300
1090
400
1000

5
200
800
1000
550
700
*/
