#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

const int MAXN = 1 << 10;
const int LIM = 1000;

int n, r, c;
int vec[MAXN * MAXN];
int cnt[MAXN * MAXN];
bool pr[MAXN * MAXN];
vector<int> primes;

void erato() {
    pr[0] = true;
    pr[1] = true;
    for(long long i = 2; i <= 1000000; i ++)
        if(!pr[i])
            for(long long j = i * i; j <= 1000000; j += i)
                pr[j] = true;

    for(int i = 2; i <= LIM; i ++)
        if(!pr[i])
            primes.pb(i);
}

int cntPrimes(int x) {
    if(x == 1) return 0;
    if(!pr[x]) return 1;

    for(int i = 0; i < primes.size() && primes[i] * primes[i] <= x; i ++)
        if(x % primes[i] == 0) {
            while(x % primes[i] == 0)
                x /= primes[i];
            return 1 + cnt[x];
        }
}

bool cmp(int a, int b) {
    if(cnt[a] != cnt[b]) return cnt[a] < cnt[b];
    return a < b;
}

int main()
{
    erato();

    cin >> n >> r >> c;
    r --, c --;

    for(int i = 0; i < n * n; i ++) {
        vec[i] = i + 1;
        cnt[i + 1] = cntPrimes(i + 1);
    }

    sort(vec, vec + n * n, cmp);
    cout << vec[r * n + c] << endl;

    return 0;
}
