#include <iostream>
#include <algorithm>

using namespace std;

int n, m, w, h;
int tbl[100][100];
const bool DEBUG=false;
void spread(int x, int y){
     if(tbl[y][x]==-1)return;
     if(tbl[y][x]==1)return;
     tbl[y][x]=1;
     if(x>0)     spread(x-1, y);
     if(x<w-1)   spread(x+1, y);
     if(y>0)     spread(x, y-1);
     if(y<h-1)   spread(x, y+1);
     return; 
}
void debug(){
  if(DEBUG){
    for(int x=0; x<w; x++)
    {
    for(int y=0; y<h; y++)
    if(tbl[y][x]==-1)cout<<"#\t"; else
    cout<<tbl[y][x]<<"\t";
    cout<<endl;
    }   
    cout<<endl;
}
}
int main(){
    cin>>n>>m;
    memset(tbl, 0, 100*100);
    w=n;
    h=m;
    
    
    int k;
    cin>>k;
    for(int i=0; i<k; i++){
            int x,y;
            cin>>x>>y;
            tbl[y-1][x-1]=-1;        
    }

    int minv=0;

    for(int y=0; y<h; y++)
    for(int x=0; x<w; x++)
    if(tbl[y][x]==0)
    {
    spread(x, y);
    debug();
    minv++;
    }             

    
    
    cout<<minv<<endl;

    return 0;
}
