#include <iostream>
#include <vector>

using namespace std;

vector<int> salaries;
vector<int> biggerSalary;
vector<int> iterated;

void newIteration(bool& isChanged, int n)
{
      for(int i = 0; i<n-1; i++) 
      {   
        salaries[i] = iterated[i];
        for(int j = i+1; j<n; j++) 
        {        
            if(iterated[j] > iterated[i])
            {
                isChanged = true;
                iterated[i] = (iterated[i] + iterated[j]) / 2;
                break;
            }        
        }
      }
}

bool ifIsStatusChanged(int n)
{   
      for(int i = 0; i<n-1; i++)           
          if(iterated[i] > iterated[biggerSalary[i]])
              return true;
              
      return false;
}

int main()
{
    int n, numIterations = 1; 
    
    bool isChanged = 0, isStatusChanged =0;
    
    cin>>n;
    salaries.resize(n);
    biggerSalary.resize(n);
    iterated.resize(n);
    
    for(int i = 0; i<n; i++)
    {
        cin>>salaries[i];
        biggerSalary[i] = i;
    }
        
    iterated[n-1] = salaries[n-1];
    for(int i = 0; i<n-1; i++) 
    {   
        iterated[i] = salaries[i];
        for(int j = i+1; j<n; j++)            
            if(salaries[j] > salaries[i])
            {
                isChanged = true;
                iterated[i] = (salaries[i] + salaries[j]) / 2;
                biggerSalary[i] = j;
                break;
            }
    }
    
      
    if(!isChanged)
    { 
          for(int i = 0; i<n; i++)
              cout<<salaries[i]<<endl;
          return 0;
    }
    
    
    for(int i = 0; i<n; i++)
    {   
        if(biggerSalary[i] != i)
        {
         int min = biggerSalary[i];
         for(int j = i+1; j<n; j++)            
              if(salaries[j] > salaries[i] && salaries[j] < salaries[min] )
                    min = j;
         biggerSalary[i] = min;
         }  
    }  
    
    
    isStatusChanged = ifIsStatusChanged(n);
    if(isStatusChanged == true)
    { 
        for(int i = 0; i<n; i++)
        cout<<salaries[i]<<endl;
        return 0;
    }
        
      for(int i = 0; i<11; i++)
      {
              numIterations++;
              
              for(int i = 0; i<n-1; i++)
                      salaries[i] = iterated[i];
              
              newIteration(isChanged,n);
              isStatusChanged = ifIsStatusChanged(n);
              
              if(!isChanged || isStatusChanged==true)
              { 
                for(int i = 0; i<n; i++)
                cout<<salaries[i]<<endl;
                return 0;
              }
     }
     for(int i = 0; i<n; i++)
             cout<<iterated[i]<<endl;         
    return 0;
}
