#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <string.h>
using namespace std;

int n;
int sal[100001];
int larger[100001];
int sal_rem[100001];
pair<int,int> relarr[100001];
pair<int,int> rem[100001];

pair<int,int> stk[100001];
int sL=0;

void GetRelativityArr()
{
    int i;

    for (i=1;i<=n;i++)
    {
        relarr[i].first=sal[i];
        relarr[i].second=i;
    }

    sort(relarr+1,relarr+1+n);

    for (i=n;i>1;i--)
    {
        if (relarr[i-1].first==relarr[i].first)
        {
            relarr[i].first=0;
        }
        else
        {
            relarr[i].first=1;
        }
    }
    relarr[1].first=1;

    return;
}

void FindLargers()
{
    int i;

    memset(larger,0,sizeof(larger));

    for (i=1;i<=n;i++)
    {
        while(sL>0 && stk[sL].first<sal[i])
        {
            larger[ stk[sL].second ]=i;
            sL--;
        }

        sL++;
        stk[sL]=make_pair(sal[i],i);
    }

    return;
}

void MakeRaises()
{
    int i;

    for (i=1;i<=n;i++)
    {
        if (larger[i]!=0)
        {
            sal[i]=(sal[i]+sal[ larger[i] ])/2;
        }
    }

    return;
}

int main()
{
    int i,j;
    bool bad;

    scanf("%d",&n);

    for (i=1;i<=n;i++)
    {
        scanf("%d",&sal[i]);
    }

    for (i=1;i<=12;i++)
    {
        GetRelativityArr();
        for (j=1;j<=n;j++)
        {
            rem[j]=relarr[j];
            sal_rem[j]=sal[j];
        }

        FindLargers();
        MakeRaises();

        GetRelativityArr();

        bad=false;
        for (j=1;j<=n;j++)
        {
            if (relarr[j].first!=rem[j].first || relarr[j].second!=rem[j].second)
            {
                bad=true;
                break;
            }
        }

        if (bad)
        break;

        bad=true;
        for (j=1;j<=n;j++)
        {
            if (sal[j]!=sal_rem[j])
            {
                bad=false;
                break;
            }
        }

        if (bad)
        break;
    }

    if (i==13)
    {
        for (i=1;i<=n;i++)
        {
            printf("%d\n",sal[i]);
        }
    }
    else
    {
        for (i=1;i<=n;i++)
        {
            printf("%d\n",sal_rem[i]);
        }
    }

    return 0;
}
