#include <cstdio>
#include <vector>
#include <algorithm>
#define white 0
#define black 1
using namespace std;

typedef vector <int> vi;
typedef pair <int,int> ii;

int n,a[100001],t[100001];
vi dfsn,topo;
vector < vector <ii> > adj(100001);

void inp()
{
    scanf("%d", &n);
    for (int i=0;i<n;i++)
        scanf("%d", &a[i]);
}

void makeGraph()
{
    adj.clear();
    for (int i=0;i<n;i++)
        for (int j=i+1;j<n;j++)
            if (a[i]<a[j])
            {
                adj[i].push_back(ii(j,0));
                break;
            }
}

void dfs(int u)
{
    dfsn[u]=black;
    for (int i=0;i<adj[u].size();i++)
    {
        ii v=adj[u][i];
        if (dfsn[v.first]==white)
            dfs(v.first);
    }
    topo.push_back(u);
}

int main()
{
    inp();
    int cntl=0;
    do
    {
        makeGraph();
        topo.clear();
        dfsn.assign(n,white);
        for (int i=0;i<n;i++)
            if (dfsn[i]==white)
                dfs(i);

        reverse(topo.begin(),topo.end());
        for (int i=0;i<topo.size();i++)
        {
            ii v; v.first=-1;
            for (int j=0;j<adj[topo[i]].size();j++)
                v=adj[topo[i]][j];
            if (v.first!=-1)
                t[topo[i]]=(a[topo[i]]+a[v.first])/2;
        }

        for (int i=0;i<n;i++)
            if (t[i])
                a[i]=t[i];
        cntl++;
    } while (cntl<11);

    for (int i=0;i<n;i++)
        printf("%d\n", a[i]);

    return 0;
}
/*
4
100
50
450
200
*/
