#include<iostream>
#include<cstdio>
#include<queue>
using namespace std;
queue <int> q1,q2;
int a[256][256];
void bfs(int x,int y)
{
    q1.push(x);
    q2.push(y);
    while(!q1.empty())
    {
        x=q1.front();
        y=q2.front();
        q1.pop();
        q2.pop();
        a[x][y]=1;
        if(a[x+1][y]==0)bfs(x+1,y);
        if(a[x-1][y]==0)bfs(x-1,y);
        if(a[x][y+1]==0)bfs(x,y+1);
        if(a[x][y-1]==0)bfs(x,y-1);
    }
}
int main()
{
    int n,m,br=0;
    cin>>n>>m;
    int k;
    cin>>k;
    int x,y;
    for(int i=1;i<=k;i++)
    {
        scanf("%d%d",&x,&y);
        a[x][y]=1;
    }
    for(int i=0;i<=n+1;i++)
    {
        a[i][0]=1;
        a[i][m+1]=1;
    }
    for(int i=0;i<=m+1;i++)
    {
        a[n+1][i]=1;
        a[0][i]=1;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(a[i][j]==0){bfs(i,j);br++;}
        }
    }

    cout<<br<<endl;
    return 0;
}
/*


9 8
29
1 1
1 5
1 6
1 7
2 2
2 3
2 6
3 4
3 6
3 8
4 3
4 6
5 2
5 4
5 8
6 3
6 4
6 5
6 6
6 7
6 8
8 1
8 2
8 4
8 5
8 6
8 7
9 2
9 4

*/
