#include<iostream>

using namespace std;

int avg(int a1, int a2) {
	return (a1 + a2)/2;
}

void copyArr(int *&orig, int *out, int len) {
	for(int i = 0; i < len; i++) {
		out[i] = orig[i];
	}
}

bool sameArr(int *arr1, int *arr2, int len) {
	for(int i = 0; i < len; i++) {
		if(arr1[i] != arr2[i]) {
			return false;
		}
	}
	return true;
}

bool zStatus(int *predi, int *sled, int len) {
	for(int i = 1; i < len; i++) {
		int zapl = predi[i];
		int nzapl = sled[i];
		
		for(int j = i; j <= len; j++) {
			int zapl2 = predi[j];
			int nzapl2 = sled[j];

			if(!((zapl > zapl2 && nzapl > nzapl2) || (zapl < zapl2 && nzapl < nzapl2) || (zapl == zapl2 && nzapl == nzapl2))) {
				return false;
			}
		}
	}
	return true;
}

void iterate(int *zaplati, int N) {
	int iter = 0;

	int *predi = new int[N+1];

	do {
		copyArr(zaplati, predi, N+1);

		for(int i = 1; i < N; i++) {

			int zapl = zaplati[i];
			int sl2_idx = 0;

			for(int j = i+1; j <= N; j++) {
				if(zaplati[j] > zapl) {
					sl2_idx = j;
					break;
				}
			}

			if(sl2_idx > 0 && zaplati[sl2_idx] > zapl) {
				int zapl2 = zaplati[sl2_idx];

				int nova = avg(zapl, zapl2);
				zaplati[i] = nova;
			}
		}

		iter++;
	} while(!sameArr(predi, zaplati, N+1) && iter <= 12 && zStatus(predi, zaplati, N+1));

		if(iter < 12) {
			for(int i = 1; i <= N; i++) {
				cout<<predi[i]<<endl;
			}
			return;
		} else {
			for(int i = 1; i <= N; i++) {
				cout<<zaplati[i]<<endl;
			}
			return;
		}
}

int main() {
	int N = 0;
	
	ios::sync_with_stdio(false);

	cin>>N;
	
	int *zaplati = new int[N+1];

	for(int i = 1; i <= N; i++) {
		cin>>zaplati[i];
	}

	iterate(zaplati, N);
}