#include<iostream>
#include "math.h"

using namespace std;

int adjp(int* a, int* p, int i, int d, int b, int c) {

	int pi = p[i];
	int pip = p[i-1];

	int diff = abs(pi - pip);

	if(diff <= d) return pi;

	bool inc = false;

	if(pi == c) {
		inc = false;
	} else if (pi == b) {
		inc = true;
	}

	do {
		if(inc) pi++; else pi--;
	} while(abs(pi - pip) > d);

	return pi;
}

int main() {
	ios::sync_with_stdio(false);

	int n, b, c, d;

	cin>> n >> b >> c >> d;

	int *a = new int[n+1];
	int *p = new int[n+1];

	for(int i = 1; i <= n; i++) {
		cin >> a[i];
	}

	int sum = 0;

	for(int i = 1; i <= n; i++) {
		int pi = 0;
		if(a[i] > 0) pi = c;
		else if(a[i] < 0) pi = b;
		p[i] = pi;
		if(i > 1) {
			pi = adjp(a, p, i, d, b, c);
			p[i] = pi;
		}

		sum += a[i] * p[i];
	}

	cout<<sum<<endl;

	return 0;
}