#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef unsigned long long int u64;
struct Employee
{
    int number;
    int salary;
};
typedef struct Employee Employee;
int N;
u64 salary[100005] = {};
u64 newSalary[100005] = {};
vector<Employee> e1;
vector<Employee> e2;
void printSolution()
{
    for(int i = 0; i < N; ++i)
    {
        cout<<salary[i]<<"\n";
    }
}
void debug()
{
    cout<<"DEBUG:\n";
    for(int i = 0; i < N; ++i)
    {
        cout<<newSalary[i]<<"\n";
    }
}
bool cmp(Employee a, Employee b)
{
    return a.salary < b.salary;
}
int main()
{
    ios::sync_with_stdio(false);
    cin >> N;
    for(int i = 0; i < N; ++i)
    {
        cin >> salary[i];
        newSalary[i] = salary[i];
        Employee a, b;
        a.number = i;
        a.salary = salary[i];
        e1.push_back(a);
        b.number = i;
        b.salary = salary[i];
        e2.push_back(b);
    }
    for(int it = 0; it < 12; ++it)
    {
        for(int i = 0; i < N; ++i)
        {
            for(int j = i+1; j < N; ++j)
            {
                if(salary[j] > salary[i])
                {
                    newSalary[i] = (salary[i] + salary[j]) / 2;
                    //used[i] = j;
                    Employee a;
                    a.number = i;
                    a.salary = newSalary[i];
                    e2[i] = a;
                    break;
                }
            }
        }
        bool hasChagedSalary = false;
        bool hasBalance = true;
        for(int i = 0; i < N; ++i)
        {
            if(salary[i] != newSalary[i])
            {    
                hasChagedSalary = true;
                break;
            }
        }
        sort(e2.begin(), e2.end(), cmp);
        sort(e1.begin(), e1.end(), cmp);
        for(int i = 0; i < N; ++i)
        {
            if(e1[i].number != e2[i].number)
            {
                hasBalance = false;
                break;
            }
        }
        if(!hasBalance || !hasChagedSalary)
        {
            //cout<<"NO BALANCE FOR iteration = "<<it<<endl;
            //if(!hasBalance) cout<<"NO BALANSE\n";
            //if(!hasChagedSalary) cout<<"NO SALARIES CHANGED\n";
            //debug();
            printSolution();
            return 0;
        }
        //cout<<"after iteration = "<<it<<" the salaries are: \n";
        //debug();
        for(int i = 0; i < N; ++i)
        {
            salary[i] = newSalary[i];
            e1[i] = e2[i];
        }
    }
    return 0;
}
/*
4
300
1090
400
1000
*/