#include <iostream>
#include <stdio.h>
#include <string.h>

using namespace std;

long N;
long* a;
long* b;

bool checkConditions(){
    for(long x = 0; x < N - 1; x++){
        for(long y = x + 1; y < N; y++){
            if(!((a[x] < a[y] && b[x] < b[y]) ||
            (a[x] == a[y] && b[x] == b[y]) ||
            (a[x] > a[y] && b[x] > b[y])))
            {
                //cout << a[x] << " " << a[y] << " " << b[x] << " " << b[y];
                return false;
            }
        }
    }
    return true;
}

void newIteration(){
    for(int i = 0; i < N - 1; i++){
        for(int c = i + 1; c < N; c++)
            if(a[i] < a[c]){
                a[i] = (a[i] + a[c])/2;
                break;
            }
    }
}

void transferData(){
    for(long i = 0; i < N; i++){
        b[i] = a[i];
    }
}

int main(){
    cin >> N;
    a = new long[N];
    b = new long[N];

    for(long i = 0; i < N; i++)
        cin >> a[i];

    transferData();
    int iterations = 1;
    while(checkConditions() && iterations != 12){
        transferData();
        newIteration();
        iterations++;
    }

    for(long i = 0; i < N; i++)
        cout << b[i] << endl;

    cin.sync();
    cin.get();
    return 0;
}
