#include <iostream>
#include <cmath>
using namespace std;

int N, r, c;
int primes[] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997};
int primesSize;

long checkDels(long num){
    int res = 0;
    for(int i = 0; i < primesSize; i++){
        if(num % primes[i] == 0)
            res++;
        if(num < primes[i])
            return res;
    }
    return res;
}

int main(){
    cin >> N >> r >> c;
    primesSize = sizeof(primes)/sizeof(int);

    // Naive approach
    int pos = (r-1)*N + c;


    long nums[N*N + 2];
    int cDels = 1; // Segashen broi deliteli
    long cPos = 1;
    long cNum = 0;
    bool flag = true;

    for(long i = 2; i < N*N + 1; i++){
        nums[i] = checkDels(i);
    }
    nums[1] = 1;
    while(flag){
        for(long i = 2; i < N*N + 1; i++){
            if(cPos == pos){
                flag = false;
                break;
            }
            if(nums[i] == cDels){
                cNum = i;
                cPos++;
            }
        }
        cDels++;
    }
    if(r == 1 && c == 1)
        cout << "1";
    else
        cout << cNum;
    /*
    for(int i = 0; i < N; i++){
        for(int a = 0; a < N; a++)
            cout << table[i][a] << " ";
        cout << endl;
    }*/

    cin.sync();
    cin.get();
    return 0;
}
