#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;
int n, s[1<<17], t[1<<17], it[1<<19], k=1;
pair<int, int> a[1<<17], b[1<<17];
void clean()
{
    for(int i = 1; i <= 2*k; i++)
        it[i]=0;
}
void push(int pos, int val)
{
    pos = pos+k-1;
    it[pos]=val;
    while(pos>1)
    {
        pos/=2;
        it[pos] = max(it[2*pos], it[2*pos+1]);
    }
}
int Find(int val)
{
    int pos=1;
    while(pos<=2*k)
    {
        if(it[pos]<=val) return -1;
        if(pos>=k) return pos-k+1;
        if(it[pos*2]>val) pos*=2;
        else pos = pos*2+1;
    }
    return -1;
}
void build()
{
    clean();
    for(int i = n; i > 0; i--)
    {
        int pos = Find(s[i]);
        //cout<<pos<<" "<<i<<" "<<s[i]<<endl;
        if(pos>0) t[i] = (s[i]+s[pos])/2;
        else t[i]=s[i];
        b[i].first = t[i];
        b[i].second = i;
        push(i,s[i]);
    }
    /*int p=1;
    for(int i = 1; i < 2*k; i++)
    {
        cout<<it[i]<<" ";
        if(i>=p) p*=2;
        if(i==p-1) cout<<endl;
    }*/
}
bool check()
{
    bool eq=1;
    sort(b+1, b+n+1);
    for(int i = 1; i <= n; i++)
    {
        if(a[i].second!=b[i].second) return 1;
        if(a[i].first!=b[i].first) eq=0;
        if(i>1)
        {
            if(a[i].first==a[i-1].first)
                if(b[i].first!=b[i-1].first) return 1;
            if(a[i].first>a[i-1].first)
                if(b[i].first<=b[i-1].first) return 1;
        }
    }
    if(eq) return 1;
    for(int i = 1; i <= n; i++)
    {
        a[i].first=b[i].first;
        a[i].second=b[i].second;
        s[i]=t[i];
    }
}
int main()
 {
     scanf("%d", &n);
     while(k<n)
        k*=2;
     for(int i = 1; i <= n; i++)
     {
         scanf("%d", &s[i]);
         a[i].first = s[i];
         a[i].second = i;
     }
     sort(a+1, a+n+1);
     for(int i = 1; i <= 12; i++)
     {
         build();
         /*cout<<i<<endl<<endl;
         for(int i = 1; i <= n; i++)
            printf("%d ", t[i]);
            printf("\n");*/
         if(check()) break;
     }
     for(int i = 1; i <= n; i++)
        printf("%d\n", s[i]);
     return 0;
 }
