#include <iostream>
using namespace std;
bool graph[128][128];
int used[128][128];
int N, M;
void dfs(int i, int j)
{
    used[i][j] = true;
    if(i < N && i > -1 && j < M && j > -1 )
    {
        if(used[i + 1][j] == false && graph[i + 1][j] == false)
        {
            dfs(i + 1, j);
        }
        if(used[i - 1][j] == false && graph[i - 1][j] == false)
        {
            dfs(i - 1, j);
        }
        if(used[i][j + 1] == false && graph[i][j + 1] == false)
        {
            dfs(i, j + 1);
        }
        if(used[i][j - 1] == false && graph[i][j - 1] == false)
        {
            dfs(i, j - 1);
        }
    }
}
int main()
{
    // Really!? Broj svyrzani komponenti!!???
    cin >> N >> M;
    int K;
    cin >> K;
    for(int i = 0; i < K; i++)
    {
        int x, y;
        cin >> x >> y;
        graph[x - 1][y - 1] = true;
    }
    int cnt = 0;
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < M; j++)
        {
            if(used[i][j] == false && graph[i][j] == false)
            {
                cnt++;
                dfs(i, j);
            }
        }
    }
    cout << cnt << endl;
    return 0;
}
/*
4 5
3 1 3 2 1 2 2
*/
