#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<long long> primes;
bool isP[1<<20];
long long MAX, m;
vector<long long> numbers[8];

long long iter;

void genPrimes()
{
    primes.push_back(2);
    isP[2] = true;
    for(int i=3; i<1000000; i+=2)
    {
        if(!isP[i]) {
            primes.push_back(i);
            for(int j=i; j<1000000; j+=i) isP[j] = true;
        }
    }
}

void rec(int pos, int lvl, int numb)
{
    if(numb > MAX) return;
    if(lvl > 7) return;
    
    //cout << pos << ' ' << numb << ' ' << lvl << endl;
    
    if(lvl != 0) {
        numbers[lvl-1].push_back(numb);
    }
    
    for(int i=pos; i<m; i++)
    {
        iter++;
        if(primes[i]*numb > MAX) break;
        if(i == pos && lvl!=0) rec(i,lvl, numb*primes[i]);
        else rec(i,lvl+1,numb*primes[i]);
    }
}

int main()
{
    genPrimes();
    //for(int i=0; i<20; i++) cout << primes[i] << ' '; cout << endl;
    //cout << primes.size() << endl;
    long long n, r, c;
    cin >> n >> r >> c;
    
    MAX = n*n;
    
    
    long long number = (r-1)*n + c;
    
    vector<long long>::iterator bg = primes.begin();
    vector<long long>::iterator f = primes.begin();
    
    f = lower_bound(primes.begin(), primes.end(), MAX);
    m = f-bg;
    //cout << m << endl;
    
    numbers[0].push_back(1);
    rec(0,0LL,1);
    //cout << iter << endl;
    for(int i=0; i<7; i++)
    {
        sort(numbers[i].begin(), numbers[i].end());
        
        //cout << number << ' ' << numbers[i].size() << endl;
        
        if(number <= numbers[i].size()) {
            cout << numbers[i][number-1] << endl;
            return 0;
        }
        else number -= numbers[i].size();
            
        /*for(int j=0; j<numbers[i].size(); j++) cout << numbers[i][j] << ' ';
        cout << endl;*/
    }
    
    
}