#include <iostream>
using namespace std;

inline int ChangeNext(bool *, int);
inline bool AllTurnedOn(bool *, int);

int main()
{
	int n;
	cin >> n;
	bool * bLamps = new bool[n];
	for(int i = 0; i < n; i++)
		bLamps[i] = false;
	for(int i = 0; !AllTurnedOn(bLamps, n); i++)
	{
		if(i % 2 == 0)
		{
			bLamps[0] = !bLamps[0];
			cout << (bLamps[0]?("+1"):("-1")) << endl;
		}
		else
		{
			int l_i = ChangeNext(bLamps, n);
				cout << (bLamps[l_i]?("+"):("-")) << l_i+1 << endl;
		}
	}

	delete[] bLamps;
	return 0;
}

inline int ChangeNext(bool * bLamps, int length)
{
	for(int i = 0; i < length; i++)
		if(bLamps[i])
			{
				bLamps[i+1] = !bLamps[i+1];
				return i+1;
			}
	return -1;
}

inline bool AllTurnedOn(bool * bLamps, int length)
{
	for(int i = 0; i < length; i++)
		if(!bLamps[i]) return false;
	return true;
}
