#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<cmath>
#include<queue>
using namespace std;
int n, m, k;
struct vir
{
    int x, y;
};
vir v[128];
queue<vir>q;
int used[128][128];
int ans;

void read()
{
    int i;

    scanf("%d%d%d", &n, &m, &k);

    for (i=0; i<k; i++)
    {
        scanf("%d%d", &v[i].x, &v[i].y);
        v[i].x--;
        v[i].y--;
        used[v[i].x][v[i].y]=1;
    }
}

void solve(int a, int b)
{
    int i;
    vir p, p1;
    p.x=a;
    p.y=b;
    q.push(p);

    while (!q.empty())
    {
        p=q.front();
        q.pop();

        ///vertical down
        for (i=p.x+1; i<n; i++)
        {
            if (used[i][p.y]==1)break;
            used[i][p.y]=1;
            p1.x=i;
            p1.y=p.y;
            q.push(p1);
        }
        ///vertical up
        for (i=p.x-1; i>=0; i--)
        {
            if (used[i][p.y]==1)break;
            used[i][p.y]=1;
            p1.x=i;
            p1.y=p.y;
            q.push(p1);
        }
        ///horizontal right
        for (i=p.y+1; i<m; i++)
        {
            if (used[p.x][i]==1)break;
            used[p.x][i]=1;
            p1.x=p.x;
            p1.y=i;
            q.push(p1);
        }
        ///horizontal left
        for (i=p.y-1; i>=0; i--)
        {
            if (used[p.x][i]==1)break;
            used[p.x][i]=1;
            p1.x=p.x;
            p1.y=i;
            q.push(p1);
        }
    }
}

int main()
{
    int i, j;

    read();

    for (i=0; i<n; i++)
    for (j=0; j<m; j++)
    {
        if (used[i][j]==0)
        {
            solve(i, j);
            ans++;
        }
    }
    printf("%d\n", ans);
}
