#include <iostream>
#include <vector>

using namespace std;

vector<bool> a;

bool previousSmallest(short number)
{
    for(int i=0; i<number-2; i++)
    {
        if(a[i]) return false;
    }
    if(a[number-2]) return true;
    return false;
}

void turn(short number, bool on)
{
    bool canBeTurned = false;
    if(number==1) canBeTurned = true;
    else if(previousSmallest(number)) canBeTurned = true;

    if(canBeTurned)
    {
        if(on)
        {
            a[number-1] = true;
            cout<<"+"<<number<<endl;
        }
        else
        {
            a[number-1] = false;
            cout<<"-"<<number<<endl;
        }
    }
    else
    {
        if(a[number-2]==false)
        {
            turn(number-1,true);
        }
        else
        {
            for(int i=number-2; i>=1; i--)
            {
                turn(i,false);
            }
        }
        if(on)
        {
            turn(number,true);
        }
        else
        {
            turn(number,false);
        }
    }
}

bool allOn()
{
    for(int i=0; i<a.size(); i++)
    {
        if(!a[i]) return false;
    }
    return true;
}

int main()
{
    int n;
    cin>>n;
    for(int i=0; i<n; i++)
    {
        a.push_back(false);
    }
    for(int i=0; i<n; i++)
    {
        turn(i+1,true);
    }
    while(!allOn())
    {
        for(int i=0; i<n; i++)
        {
            if(!a[i])
            {
                turn(i+1,true);
            }
        }
    }
    return 0;
}
