#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

// #define DEBUG

const int MAXN = 100005;
int n, b, c, d;
int a[MAXN];
int dp[MAXN][10];

int main() {
    scanf("%d %d %d %d", &n, &b, &c, &d);
    for(int i = 0; i < n; i++) {
        scanf("%d", a+i);
    }

    int x, y, maxm;
    for(int j, i = 0; i < n; i++) {
        for(j = b; j <= c; j++) {
            dp[i][j] = a[i]*j;

            if(i!=0) {
                x = max(b, j - d);
                y = min(c, j + d);
                maxm = -1; //max(dp[i-1][x], dp[i-1][y]);
                for(int k = x; k <= y; k++) {
                    if(dp[i-1][k] > maxm) {
                        maxm = dp[i-1][k];
                    }
                }
                dp[i][j] += maxm;
            }
        }
    }

    int res = dp[n-1][b];
    for(int j = b; j <= c; j++) {
        if(dp[n-1][j] > res) {
            res = dp[n-1][j];
        }
    }

#ifdef DEBUG
    for(int j, i = 0; i < n; i++) {
        for(j = b; j <= c; j++) {
            printf("%d ", dp[i][j]);
        }
        printf("\n");
    }
#endif

    printf("%d\n", res);
    return 0;
}
