#include <cstdio>

#define MAXN 1000
#define MAXNUM 1000000
#define NONE -1

int pdiv[MAXNUM+1],N,R,C;

void buildPD()
{
	for(int i=0; i<=MAXNUM; i++) pdiv[i]=NONE;
	pdiv[1]=0;
	int lim;
	for(int i=2; i<=MAXNUM; i++)
	{
		if(pdiv[i] == NONE)
		{
			//i is prime
			lim = MAXNUM/i;
			for(int j=1; j<=lim; j++)
				if(pdiv[j] != NONE)
				{
					if(j%i == 0) pdiv[j*i] = pdiv[j];
					else pdiv[j*i] = pdiv[j]+1;
				}
		}
	}
}

int solve()
{
	int numbers=N*N;
	int idx=(R-1)*N + C - 1;
	//printf("idx = %d\n", idx);
	int c[100];
	for(int i=0; i<100; i++) c[i]=0;
	for(int i=1; i<=numbers; i++) c[pdiv[i]]++;
	int numOfDivisors=0;
	
	
	//for(int i=0; i<10; i++) printf("%d -> %d\n", i, c[i]);
	
	while(idx-c[numOfDivisors] >= 0)
	{
		idx -= c[numOfDivisors];
		numOfDivisors++;
	}
	for(int i=1; i<=numbers; i++) { if(pdiv[i]==numOfDivisors and idx==0) return i; if(pdiv[i] == numOfDivisors) idx--; }
	return numbers;
}

int main()
{
	buildPD();
	//for(int i=1; i<=25; i++) printf("%d ", pdiv[i]); printf("\n");
	//for(int i=1; i<100; i++) printf("%d ", pdiv[i]); printf("\n");
	//printf("%d\n", pdiv[2*3]);
	
	if(true) scanf("%d%d%d", &N, &R, &C); else { N=1000;R=1000;C=1000; }
	printf("%d\n", solve());
	
	return 0;
}
