#include <stdio.h>

using namespace std;

int n, b, c, d, values[100000], coeffs[99998], answer[100000], positiveBr[99998];

int MODC(int a)
{
	if (a > c) return c;
	return a;
}

int MODB(int a)
{
	if (a < b) return b;
	return a;
}

void AddPositive(int coeffInd, int valueInd)
{
	if (values[valueInd] > 0) positiveBr[coeffInd]++;
}

int getBiggestNumberIndex(int valuesStartPos)
{
	if ((values[valuesStartPos] > values[valuesStartPos + 1]) && (values[valuesStartPos] > values[valuesStartPos + 2])) return 1;
	else if ((values[valuesStartPos] < values[valuesStartPos + 1]) && (values[valuesStartPos + 1] > values[valuesStartPos + 2])) return 2;
	else return 3;
}

void SolveLeft(int startInd)
{
	//printf("sind l: %d\n", startInd);
	for (int i = startInd - 1; i >= 0; i--)
		if (values[i] < 0) answer[i] = MODB(answer[i + 1] - d);
		else if (values[i] > 0) answer[i] = MODC(answer[i + 1] + d);
		else
		{
			if (i == 0) answer[0] = 0;
			else
			{
				if (answer[i - 1] < 0) answer[i] = MODB(answer[i + 1] - d);
				else if (answer[i - 1] >= 0) answer[i] = MODC(answer[i + 1] + d);
			}
		}
}

void SolveRight(int startInd)
{
	//printf("sind r: %d\n", startInd);
	for (int i = startInd + 1; i <= n; i++)
		if (values[i] < 0) answer[i] = MODB(answer[i - 1] - d);
		else if (values[i] > 0) answer[i] = MODC(answer[i - 1] + d);
		else
		{
			if (i == n - 1) answer[n - 1] = 0;
			else
			{
				if (answer[i + 1] < 0) answer[i] = MODB(answer[i - 1] - d);
				else if (answer[i + 1] >= 0) answer[i] = MODC(answer[i - 1] + d);
			}
		}
}

int main()
{
	scanf("%d%d%d%d", &n, &b, &c, &d);
	for (int i = 0; i < n; i++) scanf("%d", &values[i]);
	if (n <= 3)
	{
		if (n == 1)
		{
			if (values[0] >= 0) printf("%d\n", values[0] * c);
			else printf("%d\n", values[0] * b);
		}
		else if (n == 2)
		{
			if (values[0] > values[1])
			{
				int a = values[0];
				values[0] = values[1];
				values[1] = a;
			}
			if ((values[0] + values[1] < 0) && (values[0] * values[1] > 0)) printf("%d\n", values[0] * b + values[1] * b);
			else if ((values[0] + values[1] < 0) && (values[0] * values[1] <= 0)) printf("%d\n", values[0] * b + values[1] * MODC(b + d));
			else if ((values[0] + values[1] > 0) && (values[0] * values[1] >= 0)) printf("%d\n", values[0] * c + values[1] * c);
			else if ((values[0] + values[1] > 0) && (values[0] * values[1] < 0)) printf("%d\n", values[0] * MODB(c - d) + values[1] * c);
			else if ((values[0] + values[1] == 0) && (values[0] * values[1] >= 0)) printf("0\n");
			else if ((values[0] + values[1] == 0) && (values[0] * values[1] < 0)) printf("%d\n", values[0] * MODB(c - d) + values[1] * c);
		}
		else
		{
			
		}
	}
	else
	{
		coeffs[0] = values[0]; AddPositive(0, 0);
		coeffs[n - 3] = values[n - 1]; AddPositive(n - 3, n - 1);
		coeffs[0] += values[1]; AddPositive(0, 1);
		coeffs[1] += values[1]; AddPositive(1, 1);
		coeffs[n - 3] += values[n - 2]; AddPositive(n - 3, n - 2);
		coeffs[n - 4] += values[n - 2]; AddPositive(n - 4, n - 2);
		for (int i = 2; i < n - 2; i++)
		{
			coeffs[i - 2] += values[i]; AddPositive(i - 2, i);
			coeffs[i - 1] += values[i]; AddPositive(i - 1, i);
			coeffs[i] += values[i]; AddPositive(i, i);
		}
		int maxCoeffInd = 0;
		for (int i = 1; i < n - 2; i++)
			if (coeffs[maxCoeffInd] < coeffs[i]) maxCoeffInd = i;
			else if ((coeffs[maxCoeffInd] == coeffs[i]) && (positiveBr[maxCoeffInd] < positiveBr[i])) maxCoeffInd = i;
		int maxPos = getBiggestNumberIndex(maxCoeffInd);
		if (maxPos == 1)
		{
			answer[maxCoeffInd] = c;
			if (values[maxCoeffInd + 1] > 0) answer[maxCoeffInd + 1] = c;
			else if (values[maxCoeffInd + 1] < 0) answer[maxCoeffInd + 1] = MODB(c - d);
			else if (values[maxCoeffInd + 1] == 0)
			{
				if (values[maxCoeffInd + 2] >= 0) answer[maxCoeffInd + 1] = c;
				else if (values[maxCoeffInd + 2] < 0) answer[maxCoeffInd + 1] = MODB(c - d);
			}
			if (values[maxCoeffInd + 2] > 0) answer[maxCoeffInd + 2] = MODC(answer[maxCoeffInd + 1] + d);
			else if (values[maxCoeffInd + 2] < 0) answer[maxCoeffInd + 2] = MODB(answer[maxCoeffInd + 1] - d);
			else if (values[maxCoeffInd + 2] == 0)
			{
				if (maxCoeffInd + 3 < n)
				{
					if (values[maxCoeffInd + 3] >= 0) answer[maxCoeffInd + 2] = MODC(answer[maxCoeffInd + 1] + d);
					else if (values[maxCoeffInd + 3] < 0) answer[maxCoeffInd + 2] = MODB(answer[maxCoeffInd + 1] - d);
				}
			}
			SolveLeft(maxCoeffInd);
			SolveRight(maxCoeffInd + 2);
		}
		else if (maxPos == 3)
		{
			answer[maxCoeffInd + 2] = c;
			if (values[maxCoeffInd + 1] > 0) answer[maxCoeffInd + 1] = c;
			else if (values[maxCoeffInd + 1] < 0) answer[maxCoeffInd + 1] = MODB(c - d);
			else if (values[maxCoeffInd + 1] == 0)
			{
				if (values[maxCoeffInd] >= 0) answer[maxCoeffInd + 1] = c;
				else if (values[maxCoeffInd] < 0) answer[maxCoeffInd + 1] = MODB(c - d);
			}
			if (values[maxCoeffInd] > 0) answer[maxCoeffInd] = MODC(answer[maxCoeffInd + 1] + d);
			else if (values[maxCoeffInd] < 0) answer[maxCoeffInd] = MODB(answer[maxCoeffInd + 1] - d);
			else if (values[maxCoeffInd] == 0)
			{
				if (maxCoeffInd >= 0)
				{
					if (values[maxCoeffInd] >= 0) answer[maxCoeffInd] = MODC(answer[maxCoeffInd + 1] + d);
					else if (values[maxCoeffInd] < 0) answer[maxCoeffInd] = MODB(answer[maxCoeffInd + 1] - d);
				}
			}
			//printf("maxcoeff = %d\n", maxCoeffInd);
			SolveLeft(maxCoeffInd);
			SolveRight(maxCoeffInd + 2);
		}
		else
		{
			answer[maxCoeffInd + 1] = c;
			if (values[maxCoeffInd + 2] > 0) answer[maxCoeffInd + 2] = c;
			else if (values[maxCoeffInd + 2] < 0) answer[maxCoeffInd + 2] = MODB(c - d);
			else if (values[maxCoeffInd + 2] == 0)
			{
				if (values[maxCoeffInd + 3] >= 0) answer[maxCoeffInd + 2] = c;
				else if (values[maxCoeffInd + 3] < 0) answer[maxCoeffInd + 2] = MODB(c - d);
			}
			if (values[maxCoeffInd] > 0) answer[maxCoeffInd] = MODC(answer[maxCoeffInd] + d);
			else if (values[maxCoeffInd] < 0) answer[maxCoeffInd] = MODB(answer[maxCoeffInd] - d);
			else if (values[maxCoeffInd] == 0)
			{
				if (maxCoeffInd >= 0)
				{
					if (values[maxCoeffInd - 1] >= 0) answer[maxCoeffInd] = MODC(answer[maxCoeffInd] + d);
					else if (values[maxCoeffInd - 1] < 0) answer[maxCoeffInd] = MODB(answer[maxCoeffInd] - d);
				}
			}
			//printf("maxcoeff = %d\n", maxCoeffInd);
			SolveLeft(maxCoeffInd);
			SolveRight(maxCoeffInd + 2);
		}
		unsigned long long ans = 0;
		for (int i = 0; i < n; i++)/*{*/ ans += answer[i] * values[i];
		//printf("ans[i] = %d | val[i] = %d\n", answer[i], values[i]);
		//}
		printf("%llu\n", ans);
	}
	
	return 0;
}
