#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector <unsigned long long> primes;
vector <unsigned long long> sequence;
int primesSize = 1, n, sequenceSize = 1, newSequenceSize = 1, col, row;

/*!long long QuickPow(int x, int power)
{
	if (power == 1) return x;
	else if (power % 2 == 0) return QuickPow(x * x, power / 2);
	else return x * QuickPow(x, power - 1);
}*/

void MakePrimesUpToN()
{
	///primes.push_back(1);
	sequence.push_back(1);
	primes.push_back(2);
	for (int i = 3; i <= n * n; i += 2)
	{
		primes.push_back(i);
		primesSize++;
	}
	for (int i = 1; (i < primesSize) && (primes[i] <= n); i++)
		for (int j = i + 1; j < primesSize; j++)
			if (primes[j] % primes[i] == 0)
			{
				primes.erase(primes.begin() + j);
				j--;
				primesSize--;
			}
}

void DFS(int currLevel, int maxLevel, int lastUsedPrimeIndex, unsigned long long lastNumber)
{
	if (currLevel == maxLevel)
	{
		if (lastNumber <= n * n)
		{
			newSequenceSize++;
			sequence.push_back(lastNumber);
		}
		return;
	}
	else
	{
		for (int i = lastUsedPrimeIndex + 1; (i < primesSize)/* && (lastNumber * primes[i])*/; i++)
		{
			unsigned long long k = lastNumber * primes[i];
			///if (k > n * n) return;
			while (k <= n * n)
			{
				DFS(currLevel + 1, maxLevel, i, k);
				k *= primes[i];
			}
		}
	}
}

int main()
{
	scanf("%d%d%d", &n, &row, &col);
	int seqElement = (row - 1) * n + col - 1;
	if (seqElement == 0) printf("1\n");
	else
	{
		MakePrimesUpToN();
		int i = 0;
		while (sequenceSize <= seqElement)
		{
			i++;
			DFS(0, i, -1, 1);
			sort(sequence.begin() + sequenceSize, sequence.end());
			sequenceSize = newSequenceSize;
		}
		printf("%llu\n", sequence[seqElement]);
	}
	
	return 0;
}
