#include <cstdio>
#include <algorithm>

#define NN 1000000

int n, r, c;
int rc, nn;

struct Prpos
{
    Prpos () : pos (0), val (0) {};
    ~Prpos () {};

    bool operator< (const Prpos& other) const
    {
        //return
            if (val < other.val) return true;
            else if (val == other.val && pos < other.pos) return true;
            else return false;
    }

    int pos;
    int val;
};

Prpos prime[NN + 10]; // + 10 for safety;

void input ();
void sol ();
void output ();

int main ()
{
    input ();
    sol ();
    output ();

    return 0;
}

void input ()
{
    scanf ("%d%d%d", &n, &r, &c);
    rc = (r - 1) * n + c;
    nn = n * n;
}

void sol ()
{
    // prep

    prime[0].pos = 0;
    prime[1].pos = 1;

    for (int i = 2; i <= nn; i++)
    {
        prime[i].pos = i;

        if (!prime[i].val)
            for (int j = i; j <= nn; j += i)
                prime[j].val++;
    }

    // sol

    std :: sort (prime, prime + nn + 1);
}

void output ()
{
    printf ("%d\n", prime[rc].pos);
}
