#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>

using namespace std;

int const MAX_ELEMENTS = 100000;

int n, a, b, c, d;

int getBiggest(int previous) {
    for (int i = c; i >= b; i--) {
        int abs = fabs(i - previous);

        if (/* abs != 0 && */ abs <= d) return i;
    }

    return 0; // or 1?
}

int getLowest(int previous) {
    for (int i = b; i <= c; i++) {
        int abs = fabs(i - previous);

        if (/*abs != 0 && */ abs <= d) return i;
    }

    return 0; // or 1?
}

int main() {
    cin >> n >> b >> c >> d;

    int nums[n];
    int pows[n];

    // Reads input data
    for (int i = 0; i < n; i++) {
        cin >> a;
        nums[i] = a;
    }

    // No elements => maximal sum = 0
    if (n == 0) {
        cout << 0;
        return 0;
    }

    if (nums[0] > 0) pows[0] = c;
    else pows[0] = b;

    for (int i = 1; i < n; i++) {
        if (nums[i] < 0) pows[i] = getLowest(pows[i - 1]);
        else if (nums[i] > 0) pows[i] = getBiggest(pows[i - 1]);
    }

    long sum = 0;

    // Calculate maximal sum
    for (int i = 0; i < n; i++) sum += nums[i] * pows[i];

    cout << sum;

    return 0;
}
