#include <iostream>
#include <stdio.h>

using namespace std;

const int MAXN = 100100;
const int INF = 1 << 30;

int n, b, c, d;
int a[MAXN];
int dp[MAXN][16];

void read() {
    scanf("%d %d %d %d", &n, &b, &c, &d);
    for(int i = 1; i <= n; i ++)
        scanf("%d", &a[i]);
}

int abss(int x) {
    if(x < 0) return -x;
    return x;
}

void solve() {
    for(int p = b; p <= c; p ++)
        dp[1][p] = a[1] * p;

    for(int i = 2; i <= n; i ++)
        for(int p = b; p <= c; p ++) {
            dp[i][p] = -INF;
            for(int oldp = b; oldp <= c; oldp ++)
                if(abss(p - oldp) <= d)
                    dp[i][p] = max(dp[i][p], a[i] * p + dp[i - 1][oldp]);
        }

    int ans = -INF;
    for(int p = b; p <= c; p ++)
        ans = max(ans, dp[n][p]);
    cout << ans << endl;
}

int main()
{
    read();
    solve();

    return 0;
}
