/**
Contest: NOI 2014, Round 2
Task: A2.sumprod
Nikola Stoyanov
29.03.2014, Varna
*/

#include <cstdio>
#include <algorithm>

void input ();
void solve ();
int findMax (int l, int r, int* arr);

int n;
int limL, limR, dif;
int* seqA = 0;

int main ()
{
	input ();
	solve ();

	if (seqA)
		delete[] seqA;
	return 0;
}

void input ()
{
	scanf ("%d%d%d%d", &n, &limL, &limR, &dif);
	seqA = new int[n];
	for (int i=0; i < n; i++)
	{
		scanf ("%d", seqA+i);
	}
}

void solve ()
{
	int dp[2][10] = {0};

	for (int row=0; row < n; row++)
	{
		for (int col=limL; col <= limR; col++)
		{
			dp[1][col] = findMax (std::max (limL, col-dif), std::min (limR, col+dif)+1, dp[0]) + col * seqA[row];
		}
		std::swap (dp[0], dp[1]);
	}

	printf ("%d\n", findMax (limL, limR+1, dp[0]));
}

int findMax (int l, int r, int* arr)
{
	int ret = -1000000000;
	for (int i=l; i < r; i++)
	{
		if (arr[i] > ret)
			ret = arr[i];
	}

	return ret;
}
