/**
Contest: NOI 2014, Round 2
Task: A3.tab
Nikola Stoyanov
29.03.2014, Varna
*/

#include <iostream>
#include <deque>

struct Tabnum
{
	Tabnum ()
		: num (0), del (0)
	{
	}

	Tabnum (int _num, int _del)
		: num (_num), del (_del)
	{
	}

	int num;
	int del;
};

void input ();
int calcTab ();

int n;
int looked;

int main ()
{
	input ();

	if (looked == 0)
		std::cout << "1\n";
	else
		std::cout << calcTab () << '\n';

	return 0;
}

void input ()
{
	int tabSz;
	int r, c;

	std::cin >> tabSz;
	n = tabSz * tabSz;

	std::cin >> r >> c;
	looked = (r-1) * tabSz + c-1;
}

int calcTab ()
{
	int cnt = 0;
	std::deque<Tabnum> tab1;
	std::deque<Tabnum> tab2;

	std::deque<Tabnum>* tab = &tab1;
	std::deque<Tabnum>* nextTab = &tab2;
	for (int i = 1; i < n; i++)
	{
		tab->push_back (Tabnum (i+1, 0));
	}

	int delCnt = 1;
	Tabnum front;
	while (!tab->empty())
	{
		while (!tab->empty())
		{
			front = tab->front();
			if (front.del == 0)
			{
				//prime
				for (int i = front.num; i < tab->size(); i+= front.num)
				{
					tab->operator[](i).del++;
				}
				cnt++;
			}
			else if (front.del == delCnt)
			{
				cnt++;
			}
			else	//tab->front().del > delCnt
			{
				nextTab->push_back (front);
			}

			if (cnt == looked)
			{
				return front.num;
			}
			tab->pop_front();
		}
		std::swap (tab, nextTab);
		delCnt++;
	}

	return 1;
}
