/**
Tournament: National olympiad in informatics 2014, Round 2
Task: A2 - sumprod - Greedy :>
Language: C/C++
Author: Vasil Sarafov
29.03.2014, Varna
**/
#include <iostream>
#include <cstdio>
#include <limits>
#define space " "
#define ln "\n";
using namespace std;

const int MAXN = (int)(1e5) + 10;
const int MIN = numeric_limits <int>::min();

int best = MIN, sum;
int n, b, c, d;
int a[MAXN], p[MAXN];

int main(void)
{
    // reading input
    scanf("%d %d", &n, &b);
    scanf("%d %d", &c, &d);
    for(int i = 1; i <= n; i++) scanf("%d", &a[i]);

    // try with maximum + function
    sum = 0;
    for(int i = 1; i <= n; i++)
    {
        if(a[i] > 0) p[i] = c;
        else p[i] = max(b, c - d);
        sum += (a[i] * p[i]);
    }

    best = max(best, sum);

    // try with minimum - function
    sum = 0;
    for(int i = 1; i <= n; i ++)
    {
        if(a[i] < 0) p[i] = b;
        else p[i] = min(c, b + d);
        sum += (a[i] * p[i]);
    }

    best = max(best , sum);

    printf("%d\n", best);

    return 0;
}
/**
4 2 4 1
2 -3 5 -1
**/

