#include <iostream>
#include <set>
#include <vector>
using namespace std;


int factors(int n) {
	
	set<int> set;
	
	int f = 2;

    while (f * f <= n)
        if (n % f == 0) {
        	set.insert(f);
        	n /= f;
        } else f++;

    if (n > 1) set.insert(n);
    
	return set.size();
}

int main() {
	
	int N, r, c, at = 1, position = 1;
	vector<int> tab;
	
	cin>>N>>r>>c;
	
	while(position != (r-1)*N+c+1) {
	
		for(int i = 1; i <= N*N; i++) {
			if(factors(i) == at) {
				tab.push_back(i);
				position++;
			}
			
			if((r-1)*N+c+1 == position) break;
		}	
		at++;	
	}
	cout<<tab[(r-1)*N+c-2];
		
	return 0;
}

